/*
 * @(#)AbacusInterface.java
 *
 * Copyright 1994 - 2010  David A. Bagley, bagleyd@tux.org
 *
 * All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software and
 * its documentation for any purpose and without fee is hereby granted,
 * provided that the above copyright notice appear in all copies and
 * that both that copyright notice and this permission notice appear in
 * supporting documentation, and that the name of the author not be
 * used in advertising or publicity pertaining to distribution of the
 * software without specific, written prior permission.
 *
 * This program is distributed in the hope that it will be "useful",
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */

import java.awt.*;

/**
 * The <code>AbacusInterface</code> class contains most of the
 * constants used by the <code>AbacusApplet</code> class.
 *
 * @author	David A. Bagley
 * @author	bagleyd@tux.org
 * @author	http:/www.tux.org/~bagleyd/abacus.html
 */

public class AbacusInterface {

	static final int ACTION_HIDE = 101;
	static final int ACTION_BASE_DEFAULT = 102;
	static final int ACTION_DEMO_DEFAULT = 103;
	static final int ACTION_CLEAR_QUERY = 104;
	static final int ACTION_CALC = 105;
	static final int ACTION_SCRIPT = 106;
	static final int ACTION_MOVE = 107;
	static final int ACTION_PLACE = 108;
	static final int ACTION_CLEAR = 200;
	static final int ACTION_COMPLEMENT = 201;
	static final int ACTION_INCREMENT = 202;
	static final int ACTION_DECREMENT = 203;
	static final int ACTION_FORMAT = 204;
	//static final int ACTION_MUSEUM = 205;
	static final int ACTION_ROMAN_NUMERAL = 206;
	//static final int ACTION_GROUP = 207;
	static final int ACTION_SIGN = 208;
	static final int ACTION_QUARTER = 209;
	static final int ACTION_QUARTER_PERCENT = 210;
	static final int ACTION_TWELFTH = 211;
	static final int ACTION_SUBDECK = 212;
	//static final int ACTION_EIGHTH = 213;
	static final int ACTION_ANOMALY = 214;
	static final int ACTION_WATCH = 215;
	static final int ACTION_TEACH = 219;
	static final int ACTION_VERTICAL = 221;
	static final int ACTION_DEMO = 300;
	static final int ACTION_NEXT = 301;
	static final int ACTION_REPEAT = 302;
	static final int ACTION_JUMP = 303;
	static final int ACTION_MORE = 304;
	static final int ACTION_IGNORE = 999;

	static final int MIN_RAILS = 1;
	static final int MIN_DEMO_RAILS = 3;
	static final int DEFAULT_RAILS = 13;
	static final int DEFAULT_LEFT_AUX_RAILS = 7;
	static final int DEFAULT_RIGHT_AUX_RAILS = 13;
	static final int DEFAULT_TOP_SPACES = 2;
	static final int DEFAULT_BOTTOM_SPACES = 2;
	static final int DEFAULT_TOP_NUMBER = 2;
	static final int DEFAULT_BOTTOM_NUMBER = 5;
	static final int DEFAULT_TOP_FACTOR = 5;
	static final int DEFAULT_BOTTOM_FACTOR = 1;
	static final boolean DEFAULT_TOP_ORIENT = true;
	static final boolean DEFAULT_BOTTOM_ORIENT = false;
	static final int MIN_BASE = 2; // Base 1 is rediculous :)
	static final int MAX_BASE = 36; // 10 numbers + 26 letters (ASCII)
	static final int DEFAULT_BASE = 10;
	static final int DEFAULT_SUBDECKS = 3;
	static final int DEFAULT_SUBBEADS = 4;
	static final int DEFAULT_SHIFT_PERCENT = 2;
	static final int DEFAULT_SHIFT_ANOMALY = 2;
	static final int DEFAULT_GROUP_SIZE = 3;
	static final int SUBDECK_SPACE = 1;
	static final int MAX_MUSEUMS = 3;
	static final int IT = 0;
	static final int UK = 1;
	static final int FR = 2;
	static final int COLOR_MIDDLE = 1;
	static final int COLOR_FIRST = 2;
	static final int COLOR_HALF = 4;
	static final int PRIMARY = 0;
	static final int LEFT_AUX = 1;
	static final int RIGHT_AUX = 2;
	static final String TEACH_STRING0 = "Enter calculation X+Y, X-Y, X*Y, X/Y, Xv, or Xu where X positive and result positive.";
	static final String TEACH_STRING1 = "Press enter to go through calculation steps.";

	static final int NORMAL = 1;
	static final int DOUBLE = 2;
	static final int INSTANT = 3;

	enum Modes {Chinese, Japanese, Korean, Roman, Russian, Danish, Generic}
	static final String[] formatStrings = {"Saun-pan", "Soroban", "Supan",
		"Hand-abacus", "Schoty", "Abacus", "Abacus"};
	static final String TITLE = "Abacus";
	static final String TINY_ICON = "icons/abacus.t.gif";
	static final String SMALL_ICON = "icons/abacus.s.gif";
	static final String MEDIUM_ICON = "icons/abacus.m.gif";
	static final String LARGE_ICON = "icons/abacus.l.gif";
	static final String ICON = "icons/abacus.gif";
	static final String[] TINY_ICONS = {"icons/abacus.t.gif",
		"icons/abacus.t.gif", "icons/abacus.t.gif",
		"icons/abacusro.t.gif", "icons/abacusru.t.gif",
		"icons/abacusdk.t.gif", "icons/abacus.t.gif"};
	static final String[] MEDIUM_ICONS = {"icons/abacus.m.gif",
		"icons/abacus.m.gif", "icons/abacus.m.gif",
		"icons/abacusro.m.gif", "icons/abacusru.m.gif",
		"icons/abacusdk.m.gif", "icons/abacus.m.gif"};
	static final String[] LARGE_ICONS = {"icons/abacus.l.gif",
		"icons/abacusjp.l.gif", "icons/abacusko.l.gif",
		"icons/abacusro.l.gif", "icons/abacusru.l.gif",
		"icons/abacusdk.l.gif", "icons/abacus.l.gif"};

	enum TestState {start, exam, finish}
	static final Color steelBlue = new Color(174, 178, 195);
	static final Color darkRed = new Color(139, 0, 0);
	static final Color limeGreen = new Color(50, 205, 50);
	static final Color gainsboro = new Color(220, 220, 220);
	static final Color tan = new Color(139, 126, 102);
	static final Color brown = new Color(139, 115, 85);
	static final Color magenta = new Color(255, 0, 255);
	static final Color gold = new Color(255, 215, 0);
	static final Color silver = new Color(202, 225, 255);
	static final Color purple = new Color(160, 32, 240);
	static final Color gray25 = new Color(64, 64, 64);

	static int setModeFromFormat(String string) {
		for (Modes mode : Modes.values()) {
			if (string.equalsIgnoreCase(mode.toString())) {
				return mode.ordinal();
			}
		}
		if (string.equalsIgnoreCase("Italian")) {
			return Modes.Roman.ordinal();
		} else if (string.equalsIgnoreCase("cn")) {
			return Modes.Chinese.ordinal();
		} else if (string.equalsIgnoreCase("zh")) {
			return Modes.Chinese.ordinal();
		} else if (string.equalsIgnoreCase("ja")) {
			return Modes.Japanese.ordinal();
		} else if (string.equalsIgnoreCase("jp")) {
			return Modes.Japanese.ordinal();
		} else if (string.equalsIgnoreCase("ko")) {
			return Modes.Korean.ordinal();
		} else if (string.equalsIgnoreCase("ro")) {
			return Modes.Roman.ordinal();
		} else if (string.equalsIgnoreCase("it")) {
			return Modes.Roman.ordinal();
		} else if (string.equalsIgnoreCase("ru")) {
			return Modes.Russian.ordinal();
		} else if (string.equalsIgnoreCase("dk")) {
			return Modes.Danish.ordinal();
		} else if (string.equalsIgnoreCase("da")) {
			return Modes.Danish.ordinal();
		} else {
			return Modes.Generic.ordinal();
		}
	}

	static int setMuseumFromFormat(String string) {
		if (string.equalsIgnoreCase("it")) {
			return IT;
		} else if (string.equalsIgnoreCase("uk")) {
			return UK;
		} else if (string.equalsIgnoreCase("fr")) {
			return FR;
		}
		return MAX_MUSEUMS;
	}
}
